
'On Error Resume Next
Dim FSO, sSPFile, PercentageComplete, sProgressValue
Dim SPPercentage, LPPercentage, Drivepath, RootPath
Dim printersCaptured
Dim printersRestored
Dim networkSharesCaptured
Dim networkSharesRestored
Dim OldPCName
Dim scanStateExitCode
Dim loadStateExitCode

Dim USMTTaskname

Set FSO = CreateObject("Scripting.FileSystemObject")
Const ForReading = 1
USMTTaskname = "Run USMT"

FindPath()

On Error Resume Next

MBToTransfer(DrivePath & "\USMTcapture.prg")
SPPercentComplete(DrivePath & "\USMTcapture.prg")
LPPercentComplete(DrivePath & "\Loadstateprogress.log")
'LPPercentComplete(DrivePath & "\Loadstateprogress.prg")

printersCaptured = GetPrinetrsCount()
networkSharesCaptured = GetNetworkShareCount()

'printersRestored = GetPrinetrsCount(DrivePath & "\PrintersRestored.xml")
'networkSharesRestored = GetNetworkShareCount(DrivePath & "\PrintersRestored.xml")

GetOldPCComputerName(RootPath & "\OldPCName.txt")

GetRestoreProcessExitCode()



GetScanProcessExitCode(DrivePath & "\OSDSetupWizardOldPC.log")



WriteTSVariables()



'||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'Functions & Subroutines
'||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
Function MBToTransfer(sSPFile)
Dim oFile, strContents, arrWords
Dim strWord, sTrim
Set oFile = FSO.OpenTextFile(sSPFile, ForReading)

strContents = oFile.ReadAll
oFile.Close

arrWords = Split(strContents, vbCr)
For Each strWord in arrWords
    If InStr(strWord, "totalSizeInMBToTransfer") Then
        'Wscript.echo strWord 
        sTrim = instrrev(strWord, "," )
            'Wscript.echo sTrim
        sProgressValue = Right(strWord,Len(strWord) -sTrim) 
            'Wscript.echo sProgressValue     
    End IF
Next
End Function 


Function SPPercentComplete(sFile)
Dim oFile, strContents, arrWords
Set oFile = FSO.OpenTextFile(sFile, ForReading)

strContents = oFile.ReadAll
oFile.Close

    arrWords = Split(strContents, vbCr)

        dim arrCount 'as int
        arrCount = Ubound(arrWords) -1

dim strSeq ' as string
strSeq = "totalPercentageCompleted"
dim i ' as int

' loop thru backwards to find sequence
for i = arrCount to 0 step -1
    
    dim pos ' as int
    pos = Instr( arrWords(i), strSeq ) 
    if pos > 0 then    

        ' ex: 15 Jan 2011, 20:46:21 -08:00, 00:04:48, totalPercentageCompleted, 48
        dim tmpResult ' as string
        tmpResult = Right ( arrWords(i), pos -1)
        PercentageComplete = Right (tmpResult, 3)
        SPPercentage = PercentageComplete
         'Wscript.echo SPPercentage
        exit for
    end if
Next    
End Function 

Function LPPercentComplete(sFile)
Dim oFile, strContents, arrWords
Set oFile = FSO.OpenTextFile(sFile, ForReading)

    ' check if file exists
    if FSO.FileExists(sFile) = False Then
        Set PathEnv = CreateObject("Microsoft.SMS.TSEnvironment")
        PathEnv("OSDLoadStateLogExists") = "False"        
        Exit Function    
    End If

strContents = oFile.ReadAll
oFile.Close

    arrWords = Split(strContents, vbCr)

        dim arrCount 'as int
        arrCount = Ubound(arrWords) -1

dim strSeq ' as string
strSeq = "totalPercentageCompleted"
dim i ' as int

' loop thru backwards to find sequence
for i = arrCount to 0 step -1
    
    dim pos ' as int
    pos = Instr( arrWords(i), strSeq ) 
    if pos > 0 then    

        ' ex: 15 Jan 2011, 20:46:21 -08:00, 00:04:48, totalPercentageCompleted, 48
        dim tmpResult ' as string
        tmpResult = Right ( arrWords(i), pos -1)
        PercentageComplete = Right (tmpResult, 3)
        LPPercentage = PercentageComplete
        'Wscript.echo LPPercentage
        exit for
    end if
Next    
End Function 

Function GetPrinetrsCount()

    Dim objXMLDoc, Root, NodeList
    Set objXMLDoc = CreateObject("Microsoft.XMLDOM") 
    objXMLDoc.async = False 
    Dim sFile 
	sFile = DrivePath & "\PrinterList.xml"
    ' check if file exists
    if FSO.FileExists(sFile) = False Then
        sFile = RootPath & "\PrinterList.xml"
	if FSO.FileExists(sFile) = False Then
	        Set PathEnv = CreateObject("Microsoft.SMS.TSEnvironment")
        	PathEnv("OSDGetPrintersLogExists") = "False"        
	        Exit Function   
	End If 
    End If

    If objXMLDoc.load(sFile) Then
        Set Root = objXMLDoc.documentElement 
        Set NodeList = Root.getElementsByTagName("Printer") 
       ' wscript.echo NodeList.length
        GetPrinetrsCount = NodeList.length
    Else
        wscript.echo "Failed to load"
    End If

    Set objXMLDoc = Nothing

End Function 



Function GetNetworkShareCount()

    Dim objXMLDoc, Root, NodeList
    Set objXMLDoc = CreateObject("Microsoft.XMLDOM") 
    objXMLDoc.async = False 
    Dim sFile 
	sFile = DrivePath & "\PrinterList.xml"
    ' check if file exists
    if FSO.FileExists(sFile) = False Then
        sFile = RootPath & "\PrinterList.xml"
	if FSO.FileExists(sFile) = False Then
	        Set PathEnv = CreateObject("Microsoft.SMS.TSEnvironment")
        	PathEnv("OSDGetPrintersLogExists") = "False"        
	        Exit Function   
	End If 
    End If

    If objXMLDoc.load(sFile) Then
        Set Root = objXMLDoc.documentElement 
        Set NodeList = Root.getElementsByTagName("NetworkShare") 
       ' wscript.echo NodeList.length
        GetNetworkShareCount = NodeList.length
    Else
        wscript.echo "Failed to load"
    End If

    Set objXMLDoc = Nothing
End Function 


Function GetOldPCComputerName(sFile)

    Dim oFile, strContents, arrWords
    
    Set oFile = FSO.OpenTextFile(sFile, ForReading)
    'strContents = oFile.ReadAll
    OldPCName = oFile.ReadLine
    oFile.Close
    
End Function

Function GetRestoreProcessExitCode()

    Dim smsFile
    Dim oFile, strContents, arrLines, eachLine
    Dim strWord, sTrim
    Dim oFolder

    Dim logFileName
    ''For each file that starts witj smsts*.log
    Dim foundExitCode
    
    foundExitCode = False
    set oFolder = FSO.GetFolder(DrivePath)

    For Each smsFile In oFolder.Files
        If (foundExitCode = False) Then ' Skip if exit code already found 
            If ( UCase (Left (smsFile.Name, 5)) = "SMSTS" ) Then  ' read only smsts files
               
                logFileName = DrivePath & "\" & smsFile.Name
                'smsFile = DrivePath & "\SMSTS.log"
                Set oFile = FSO.OpenTextFile(logFileName, ForReading)        
                strContents = oFile.ReadAll
                oFile.Close
                arrLines = Split(strContents, vbCr)
                For Each eachLine in arrLines
                    If (foundExitCode = False) Then
'  <![LOG[LoadState return code: 0]LOG]!><time="21:05:56.124+480" date="02-19-2011" component="InstallSoftware" context="" type="1" thread="2776" file="runcommandline.cpp:34">
                        If InStr(eachLine, "LoadState return code:") Then
                            foundExitCode = True
	                        sColon = instr(eachLine, ":" )
                            sTrim = instr(eachLine, "]" )
                            loadStateExitCode = Mid(eachLine,sColon+1 , sTrim-1-sColon ) 
                            '    Wscript.echo loadStateExitCode     
                        End If
                    End If
                Next

            End If
        End If 
	Next
    
    If (foundExitCode = False) Then
        loadStateExitCode = 0
    End If
    
End Function






Function GetScanProcessExitCode(smsFile)

    Dim oFile, strContents, arrLines, eachLine
    Dim strWord, sTrim
    Dim foundExitCode
    
    Set oFile = FSO.OpenTextFile(smsFile, ForReading,,true)  
    foundExitCode = False
    strContents = oFile.ReadAll
    oFile.Close

    Dim sANSIFileName
    Dim oANSIFile

    sANSIFileName = DrivePath & "\OSDRefreshWizardANSI.log"
    'OpenTextFile(destination, forwriting, createnew, open as Ascii) 
    Set oANSIFile = FSO.OpenTextFile(sANSIFileName, 2, True, False)
    oANSIFile.Write strContents
    oANSIFile.Close
    Set oANSIFile = Nothing

    Set oANSIFile = FSO.OpenTextFile(sANSIFileName, 1, , False)
    strContents = oANSIFile.ReadAll
    oANSIFile.Close
    Set oANSIFile = Nothing

    If FSO.FileExists(sANSIFileName) Then
       FSO.DeleteFile sANSIFileName 
      ' Wscript.echo "File deleted"
    End If 

    arrLines = Split(strContents, vbCr)
   
    For Each eachLine in arrLines
   
        If (InStr(eachLine, USMTTaskname) > 0) Then
            If (InStr(eachLine, "exit code =")) Then
                foundExitCode = True
                sTrim = instr(eachLine, "exit code =" )

' USMT log line from Wizard log: 
' 18:18:58.906 02-15-2011	1	TaskManager	Finished running task 'Run USMT'. Status = 'Error', exit code =26, task return code = 0
                scanStateExitCode = Trim( Mid (eachLine, sTrim+11, Instr(sTrim,eachLine,",")-(sTrim+11) ) )
                'Wscript.echo "Scan process Exit code :" & scanStateExitCode     
            End IF
        End IF
    Next

'    If (foundExitCode = False) Then
'        scanStateExitCode = 0
'    End If
    
End Function

Sub WriteTSVariables()
    dim Env
    dim UserStateLocal
    dim UserStateNetwork
    dim UserStateUSB
    dim osd: 
    set Env = CreateObject("Microsoft.SMS.TSEnvironment")

   ' Set a variable in the Operating System Deployment environment.
   
    Env("OSDDataMigrationToTransfer") = sProgressValue 
    Env("OSDDataMigrationScanned") = SPPercentage
    
    'If loadstateExitCode is '0' then set loadtstate percentage to 100 
    'as loadstate.exe is not logging 100% in its Loadprogress log eventhough it completed succesfully
    If (loadStateExitCode = 0 ) Then
        LPPercentage = "100"
    End IF
    Env("OSDDataMigrationRestored") = LPPercentage     

    Env("OSDNumberOfPrintersCaptured") = printersCaptured
    Env("OSDNumberOfNetworkSharesCaptured") = networkSharesCaptured
    '   Env("OSDNumberOfPrintersRestored") = printersRestored
    '   Env("OSDNumberOfNetworkSharesRestored") = networkSharesRestored
    
    Env("OSDOldComputerName") = OldPCName
    'OSDDataSourceDrive

   
    If ( Env("OSDHardLinks") = "TRUE") Then
        Env("OSDDataTransferType") = "Local"
    ElseIf  Env("SMSConnectNetworkFolderPath") <> "" Then
        Env("OSDDataTransferType") = "Network"
    ElseIf Env("OSDDataSourceDrive") <> "" Then
        Env ("OSDDataTransferType") = "USB"
    Else
       Env ("OSDDataTransferType") = "False"
    End If 

    Env("OSDCaptureProcessExitCode") = scanStateExitCode
    Env("OSDRestoreProcessExitCode") = loadStateExitCode

End Sub

Sub FindPath()
Dim PathEnv
  Set PathEnv = CreateObject("Microsoft.SMS.TSEnvironment")

 ' You can query the environment to get an existing USB path variable.
   'DrivePath = PathEnv("OSDStateStorePath") & "\" &  PathEnv("OSDDataSourceDirectory")
   'LogsPath = PathEnv("_SMSTSLogPath") 
   DrivePath = PathEnv("OSDStateStorePath") & "\SCCMLogs"
   RootPath = PathEnv("OSDStateStorePath") 
   'wscript.echo DrivePath 
End Sub

