'//----------------------------------------------------------------------------
'//
'//  Global constant and variable declarations
'//
'//----------------------------------------------------------------------------

Option Explicit

Dim oShell
Dim oFSO
Dim iRetVal
Dim sCmd
Dim sScriptDir


'//----------------------------------------------------------------------------
'//  Initialization
'//----------------------------------------------------------------------------

Set oShell = CreateObject("WScript.Shell")
Set oFSO = CreateObject("Scripting.FileSystemObject")
sScriptDir = oFSO.GetParentFolderName(WScript.ScriptFullName)



'//----------------------------------------------------------------------------
'//  Check to see if the prereq's have been satisfied
'//----------------------------------------------------------------------------

sCmd = "cscript.exe """ & sScriptDir & "\ZTIPrereq.vbs"""
iRetVal = oShell.Run(sCmd, 0, true)
If iRetVal <> 0 then
	oShell.Popup "This computer does not meet the prerequisites for deploying a new operating system.  (" & CStr(iRetVal) & ")", 0, "Prerequisite Error", 16
	WScript.Quit iRetVal
End if



'//----------------------------------------------------------------------------
'//  Launch UserGUIWiz.wsf to do the heavy lifting
'//----------------------------------------------------------------------------

sCmd =  "wscript.exe" & " " & sScriptDir & "\UserGUIWiz.wsf"
iRetVal = oShell.Run(sCmd, 1, true)


' All done

WScript.Quit iRetVal
